gtkmm: Gtk::StringList Class Reference

gtkmm 4.14.0

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Symbols | List of all members
Gtk::StringList Class Reference
ListView Classes

A list model for strings. More...

`#include <gtkmm/stringlist.h>`

Inheritance diagram for Gtk::StringList:
[legend]

## Public Member Functions
| StringList (StringList &&src) noexcept
StringList & | operator= (StringList &&src) noexcept
| ~StringList () noexcept override
GtkStringList * | gobj ()
| Provides access to the underlying C GObject.
const GtkStringList * | gobj () const
| Provides access to the underlying C GObject.
GtkStringList * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
void | append (const Glib::ustring &string)
| Appends string to self.
void | remove (guint position)
| Removes the string at position from self.
void | splice (guint position, guint n_removals, const std::vector< Glib::ustring > &additions)
| Changes self by removing n_removals strings and adding additions to it.
Glib::ustring | get_string (guint position) const
| Gets the string that is at position in self.
Public Member Functions inherited from Gtk::Buildable
| Buildable (Buildable &&src) noexcept
Buildable & | operator= (Buildable &&src) noexcept
| ~Buildable () noexcept override
GtkBuildable * | gobj ()
| Provides access to the underlying C GObject.
const GtkBuildable * | gobj () const
| Provides access to the underlying C GObject.
Glib::ustring | get_buildable_id () const
| Gets the ID of the buildable object.

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
static Glib::RefPtr< StringList > | create (const std::vector< Glib::ustring > & strings={})
| Creates a new StringList with the given strings.
Static Public Member Functions inherited from Gtk::Buildable
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.

## Protected Member Functions
| StringList (const std::vector< Glib::ustring > & strings)
Protected Member Functions inherited from Gtk::Buildable
| Buildable ()
| You should derive from this class to use it.

## Related Symbols
(Note that these are not member symbols.)
Glib::RefPtr< Gtk::StringList > | wrap (GtkStringList *object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::Buildable
Glib::RefPtr< Gtk::Buildable > | wrap (GtkBuildable *object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

A list model for strings.

Gtk::StringList is a list model that wraps an array of strings.

The items in the model are of type Gtk::StringObject.

Gtk::StringList is well-suited for any place where you would typically use a vector or array of Glib::ustring, but need a list model.

Gtk::StringList as Gtk::Buildable
  The Gtk::StringList implementation of the Gtk::Buildable interface supports adding items directly using the <items> element and specifying <item> elements for each item. Each <item> element supports the regular translation attributes “translatable”, “context” and “comments”.

  Here is a UI definition fragment specifying a Gtk::StringList
  <object class="GtkStringList">
  <items>
  <item translatable="yes">Factory</item>
  <item translatable="yes">Home</item>
  <item translatable="yes">Subway</item>
  </items>
  </object>

See also
  Gio::ListModel

Since gtkmm 3.98

## Constructor & Destructor Documentation

## ◆ StringList() [1/2]

Gtk::StringList::StringList | ( | StringList && | src | ) |
| noexcept

## ◆ ~StringList()

Gtk::StringList::~StringList | ( |  | ) |
| overridenoexcept

## ◆ StringList() [2/2]

Gtk::StringList::StringList | ( | const std::vector< Glib::ustring > & | strings | ) |
| explicitprotected

## Member Function Documentation

## ◆ append()

void Gtk::StringList::append | ( | const Glib::ustring & | string | ) |

Appends string to self.

The string will be copied. See take() for a way to avoid that.

Parameters

  string | The string to insert.

## ◆ create()

static Glib::RefPtr< StringList > Gtk::StringList::create | ( | const std::vector< Glib::ustring > & | strings = {} | ) |
| static

Creates a new StringList with the given strings.

Parameters

  strings | The strings to put in the model. Since 4.10 this parameter has a default value.

Returns
  A new Gtk::StringList.

## ◆ get_string()

Glib::ustring Gtk::StringList::get_string | ( | guint | position | ) | const

Gets the string that is at position in self.

If self does not contain position items, `nullptr` is returned.

This function returns the const char *. To get the object wrapping it, use Glib::list_model_get_item().

Parameters

  position | The position to get the string for.

Returns
  The string at the given position.

## ◆ get_type()

static GType Gtk::StringList::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GtkStringList * Gtk::StringList::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkStringList * Gtk::StringList::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GtkStringList * Gtk::StringList::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ operator=()

StringList & Gtk::StringList::operator= | ( | StringList && | src | ) |
| noexcept

## ◆ remove()

void Gtk::StringList::remove | ( | guint | position | ) |

Removes the string at position from self.

position must be smaller than the current length of the list.

Parameters

  position | The position of the string that is to be removed.

## ◆ splice()

void Gtk::StringList::splice | ( | guint | position,
|  | guint | n_removals,
|  | const std::vector< Glib::ustring > & | additions )

Changes self by removing n_removals strings and adding additions to it.

This function is more efficient than append() and remove(), because it only emits the signal_items_changed() signal once for the change.

This function copies the strings in additions.

The parameters position and n_removals must be correct (ie: position + n_removals must be less than or equal to the length of the list at the time this function is called).

Parameters

  position | The position at which to make the change.
  n_removals | The number of strings to remove.
  additions | The strings to add.

## Friends And Related Symbol Documentation

## ◆ wrap()

Glib::RefPtr< Gtk::StringList > wrap | ( | GtkStringList * | object,
|  | bool | take_copy = false )
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.